<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfWebTermin ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfWebTermin
 * @subpackage Arrays
 */
class ArrayOfWebTermin extends AbstractStructArrayBase
{
    /**
     * The WebTermin
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\WebTermin[]
     */
    public $WebTermin;
    /**
     * Constructor method for ArrayOfWebTermin
     * @uses ArrayOfWebTermin::setWebTermin()
     * @param \StructType\WebTermin[] $webTermin
     */
    public function __construct(array $webTermin = array())
    {
        $this
            ->setWebTermin($webTermin);
    }
    /**
     * Get WebTermin value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\WebTermin[]|null
     */
    public function getWebTermin()
    {
        return isset($this->WebTermin) ? $this->WebTermin : null;
    }
    /**
     * Set WebTermin value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\WebTermin[] $webTermin
     * @return \ArrayType\ArrayOfWebTermin
     */
    public function setWebTermin(array $webTermin = array())
    {
        foreach ($webTermin as $arrayOfWebTerminWebTerminItem) {
            // validation for constraint: itemType
            if (!$arrayOfWebTerminWebTerminItem instanceof \StructType\WebTermin) {
                throw new \InvalidArgumentException(sprintf('The WebTermin property can only contain items of \StructType\WebTermin, "%s" given', is_object($arrayOfWebTerminWebTerminItem) ? get_class($arrayOfWebTerminWebTerminItem) : gettype($arrayOfWebTerminWebTerminItem)), __LINE__);
            }
        }
        if (is_null($webTermin) || (is_array($webTermin) && empty($webTermin))) {
            unset($this->WebTermin);
        } else {
            $this->WebTermin = $webTermin;
        }
        return $this;
    }
    /**
     * Add item to WebTermin value
     * @throws \InvalidArgumentException
     * @param \StructType\WebTermin $item
     * @return \ArrayType\ArrayOfWebTermin
     */
    public function addToWebTermin(\StructType\WebTermin $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\WebTermin) {
            throw new \InvalidArgumentException(sprintf('The WebTermin property can only contain items of \StructType\WebTermin, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->WebTermin[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\WebTermin|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\WebTermin|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\WebTermin|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\WebTermin|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\WebTermin|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string WebTermin
     */
    public function getAttributeName()
    {
        return 'WebTermin';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfWebTermin
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
