<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetWebRasporedRequest StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:GetWebRasporedRequest
 * @subpackage Structs
 */
class GetWebRasporedRequest extends AbstractStructBase
{
    /**
     * The Od
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $Od;
    /**
     * The PodruznicaId
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $PodruznicaId;
    /**
     * The SifraUsluge
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $SifraUsluge;
    /**
     * Constructor method for GetWebRasporedRequest
     * @uses GetWebRasporedRequest::setOd()
     * @uses GetWebRasporedRequest::setPodruznicaId()
     * @uses GetWebRasporedRequest::setSifraUsluge()
     * @param string $od
     * @param int $podruznicaId
     * @param string $sifraUsluge
     */
    public function __construct($od = null, $podruznicaId = null, $sifraUsluge = null)
    {
        $this
            ->setOd($od)
            ->setPodruznicaId($podruznicaId)
            ->setSifraUsluge($sifraUsluge);
    }
    /**
     * Get Od value
     * @return string|null
     */
    public function getOd()
    {
        return $this->Od;
    }
    /**
     * Set Od value
     * @param string $od
     * @return \StructType\GetWebRasporedRequest
     */
    public function setOd($od = null)
    {
        // validation for constraint: string
        if (!is_null($od) && !is_string($od)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($od)), __LINE__);
        }
        $this->Od = $od;
        return $this;
    }
    /**
     * Get PodruznicaId value
     * @return int|null
     */
    public function getPodruznicaId()
    {
        return $this->PodruznicaId;
    }
    /**
     * Set PodruznicaId value
     * @param int $podruznicaId
     * @return \StructType\GetWebRasporedRequest
     */
    public function setPodruznicaId($podruznicaId = null)
    {
        // validation for constraint: int
        if (!is_null($podruznicaId) && !is_numeric($podruznicaId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($podruznicaId)), __LINE__);
        }
        $this->PodruznicaId = $podruznicaId;
        return $this;
    }
    /**
     * Get SifraUsluge value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getSifraUsluge()
    {
        return isset($this->SifraUsluge) ? $this->SifraUsluge : null;
    }
    /**
     * Set SifraUsluge value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $sifraUsluge
     * @return \StructType\GetWebRasporedRequest
     */
    public function setSifraUsluge($sifraUsluge = null)
    {
        // validation for constraint: string
        if (!is_null($sifraUsluge) && !is_string($sifraUsluge)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($sifraUsluge)), __LINE__);
        }
        if (is_null($sifraUsluge) || (is_array($sifraUsluge) && empty($sifraUsluge))) {
            unset($this->SifraUsluge);
        } else {
            $this->SifraUsluge = $sifraUsluge;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GetWebRasporedRequest
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
