<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for WebTermin StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:WebTermin
 * @subpackage Structs
 */
class WebTermin extends AbstractStructBase
{
    /**
     * The BesplatanUpis
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var bool
     */
    public $BesplatanUpis;
    /**
     * The Datum
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $Datum;
    /**
     * The IsOnline
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $IsOnline;
    /**
     * The KapacitetUcionice
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $KapacitetUcionice;
    /**
     * The MaxBrojPolaznika
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var int
     */
    public $MaxBrojPolaznika;
    /**
     * The PodruznicaId
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $PodruznicaId;
    /**
     * The PredbiljezbaSamoOnline
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var bool
     */
    public $PredbiljezbaSamoOnline;
    /**
     * The PredbiljezenoPolaznika
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $PredbiljezenoPolaznika;
    /**
     * The RasporedZaglavljeId
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $RasporedZaglavljeId;
    /**
     * The Ucionica
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Ucionica;
    /**
     * The Vrijeme
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Vrijeme;
    /**
     * Constructor method for WebTermin
     * @uses WebTermin::setBesplatanUpis()
     * @uses WebTermin::setDatum()
     * @uses WebTermin::setIsOnline()
     * @uses WebTermin::setKapacitetUcionice()
     * @uses WebTermin::setMaxBrojPolaznika()
     * @uses WebTermin::setPodruznicaId()
     * @uses WebTermin::setPredbiljezbaSamoOnline()
     * @uses WebTermin::setPredbiljezenoPolaznika()
     * @uses WebTermin::setRasporedZaglavljeId()
     * @uses WebTermin::setUcionica()
     * @uses WebTermin::setVrijeme()
     * @param bool $besplatanUpis
     * @param string $datum
     * @param bool $isOnline
     * @param int $kapacitetUcionice
     * @param int $maxBrojPolaznika
     * @param int $podruznicaId
     * @param bool $predbiljezbaSamoOnline
     * @param int $predbiljezenoPolaznika
     * @param int $rasporedZaglavljeId
     * @param string $ucionica
     * @param string $vrijeme
     */
    public function __construct($besplatanUpis = null, $datum = null, $isOnline = null, $kapacitetUcionice = null, $maxBrojPolaznika = null, $podruznicaId = null, $predbiljezbaSamoOnline = null, $predbiljezenoPolaznika = null, $rasporedZaglavljeId = null, $ucionica = null, $vrijeme = null)
    {
        $this
            ->setBesplatanUpis($besplatanUpis)
            ->setDatum($datum)
            ->setIsOnline($isOnline)
            ->setKapacitetUcionice($kapacitetUcionice)
            ->setMaxBrojPolaznika($maxBrojPolaznika)
            ->setPodruznicaId($podruznicaId)
            ->setPredbiljezbaSamoOnline($predbiljezbaSamoOnline)
            ->setPredbiljezenoPolaznika($predbiljezenoPolaznika)
            ->setRasporedZaglavljeId($rasporedZaglavljeId)
            ->setUcionica($ucionica)
            ->setVrijeme($vrijeme);
    }
    /**
     * Get BesplatanUpis value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return bool|null
     */
    public function getBesplatanUpis()
    {
        return isset($this->BesplatanUpis) ? $this->BesplatanUpis : null;
    }
    /**
     * Set BesplatanUpis value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param bool $besplatanUpis
     * @return \StructType\WebTermin
     */
    public function setBesplatanUpis($besplatanUpis = null)
    {
        // validation for constraint: boolean
        if (!is_null($besplatanUpis) && !is_bool($besplatanUpis)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($besplatanUpis)), __LINE__);
        }
        if (is_null($besplatanUpis) || (is_array($besplatanUpis) && empty($besplatanUpis))) {
            unset($this->BesplatanUpis);
        } else {
            $this->BesplatanUpis = $besplatanUpis;
        }
        return $this;
    }
    /**
     * Get Datum value
     * @return string|null
     */
    public function getDatum()
    {
        return $this->Datum;
    }
    /**
     * Set Datum value
     * @param string $datum
     * @return \StructType\WebTermin
     */
    public function setDatum($datum = null)
    {
        // validation for constraint: string
        if (!is_null($datum) && !is_string($datum)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($datum)), __LINE__);
        }
        $this->Datum = $datum;
        return $this;
    }
    /**
     * Get IsOnline value
     * @return bool|null
     */
    public function getIsOnline()
    {
        return $this->IsOnline;
    }
    /**
     * Set IsOnline value
     * @param bool $isOnline
     * @return \StructType\WebTermin
     */
    public function setIsOnline($isOnline = null)
    {
        // validation for constraint: boolean
        if (!is_null($isOnline) && !is_bool($isOnline)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($isOnline)), __LINE__);
        }
        $this->IsOnline = $isOnline;
        return $this;
    }
    /**
     * Get KapacitetUcionice value
     * @return int|null
     */
    public function getKapacitetUcionice()
    {
        return $this->KapacitetUcionice;
    }
    /**
     * Set KapacitetUcionice value
     * @param int $kapacitetUcionice
     * @return \StructType\WebTermin
     */
    public function setKapacitetUcionice($kapacitetUcionice = null)
    {
        // validation for constraint: int
        if (!is_null($kapacitetUcionice) && !is_numeric($kapacitetUcionice)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($kapacitetUcionice)), __LINE__);
        }
        $this->KapacitetUcionice = $kapacitetUcionice;
        return $this;
    }
    /**
     * Get MaxBrojPolaznika value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return int|null
     */
    public function getMaxBrojPolaznika()
    {
        return isset($this->MaxBrojPolaznika) ? $this->MaxBrojPolaznika : null;
    }
    /**
     * Set MaxBrojPolaznika value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param int $maxBrojPolaznika
     * @return \StructType\WebTermin
     */
    public function setMaxBrojPolaznika($maxBrojPolaznika = null)
    {
        // validation for constraint: int
        if (!is_null($maxBrojPolaznika) && !is_numeric($maxBrojPolaznika)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($maxBrojPolaznika)), __LINE__);
        }
        if (is_null($maxBrojPolaznika) || (is_array($maxBrojPolaznika) && empty($maxBrojPolaznika))) {
            unset($this->MaxBrojPolaznika);
        } else {
            $this->MaxBrojPolaznika = $maxBrojPolaznika;
        }
        return $this;
    }
    /**
     * Get PodruznicaId value
     * @return int|null
     */
    public function getPodruznicaId()
    {
        return $this->PodruznicaId;
    }
    /**
     * Set PodruznicaId value
     * @param int $podruznicaId
     * @return \StructType\WebTermin
     */
    public function setPodruznicaId($podruznicaId = null)
    {
        // validation for constraint: int
        if (!is_null($podruznicaId) && !is_numeric($podruznicaId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($podruznicaId)), __LINE__);
        }
        $this->PodruznicaId = $podruznicaId;
        return $this;
    }
    /**
     * Get PredbiljezbaSamoOnline value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return bool|null
     */
    public function getPredbiljezbaSamoOnline()
    {
        return isset($this->PredbiljezbaSamoOnline) ? $this->PredbiljezbaSamoOnline : null;
    }
    /**
     * Set PredbiljezbaSamoOnline value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param bool $predbiljezbaSamoOnline
     * @return \StructType\WebTermin
     */
    public function setPredbiljezbaSamoOnline($predbiljezbaSamoOnline = null)
    {
        // validation for constraint: boolean
        if (!is_null($predbiljezbaSamoOnline) && !is_bool($predbiljezbaSamoOnline)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($predbiljezbaSamoOnline)), __LINE__);
        }
        if (is_null($predbiljezbaSamoOnline) || (is_array($predbiljezbaSamoOnline) && empty($predbiljezbaSamoOnline))) {
            unset($this->PredbiljezbaSamoOnline);
        } else {
            $this->PredbiljezbaSamoOnline = $predbiljezbaSamoOnline;
        }
        return $this;
    }
    /**
     * Get PredbiljezenoPolaznika value
     * @return int|null
     */
    public function getPredbiljezenoPolaznika()
    {
        return $this->PredbiljezenoPolaznika;
    }
    /**
     * Set PredbiljezenoPolaznika value
     * @param int $predbiljezenoPolaznika
     * @return \StructType\WebTermin
     */
    public function setPredbiljezenoPolaznika($predbiljezenoPolaznika = null)
    {
        // validation for constraint: int
        if (!is_null($predbiljezenoPolaznika) && !is_numeric($predbiljezenoPolaznika)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($predbiljezenoPolaznika)), __LINE__);
        }
        $this->PredbiljezenoPolaznika = $predbiljezenoPolaznika;
        return $this;
    }
    /**
     * Get RasporedZaglavljeId value
     * @return int|null
     */
    public function getRasporedZaglavljeId()
    {
        return $this->RasporedZaglavljeId;
    }
    /**
     * Set RasporedZaglavljeId value
     * @param int $rasporedZaglavljeId
     * @return \StructType\WebTermin
     */
    public function setRasporedZaglavljeId($rasporedZaglavljeId = null)
    {
        // validation for constraint: int
        if (!is_null($rasporedZaglavljeId) && !is_numeric($rasporedZaglavljeId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($rasporedZaglavljeId)), __LINE__);
        }
        $this->RasporedZaglavljeId = $rasporedZaglavljeId;
        return $this;
    }
    /**
     * Get Ucionica value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getUcionica()
    {
        return isset($this->Ucionica) ? $this->Ucionica : null;
    }
    /**
     * Set Ucionica value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $ucionica
     * @return \StructType\WebTermin
     */
    public function setUcionica($ucionica = null)
    {
        // validation for constraint: string
        if (!is_null($ucionica) && !is_string($ucionica)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($ucionica)), __LINE__);
        }
        if (is_null($ucionica) || (is_array($ucionica) && empty($ucionica))) {
            unset($this->Ucionica);
        } else {
            $this->Ucionica = $ucionica;
        }
        return $this;
    }
    /**
     * Get Vrijeme value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getVrijeme()
    {
        return isset($this->Vrijeme) ? $this->Vrijeme : null;
    }
    /**
     * Set Vrijeme value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $vrijeme
     * @return \StructType\WebTermin
     */
    public function setVrijeme($vrijeme = null)
    {
        // validation for constraint: string
        if (!is_null($vrijeme) && !is_string($vrijeme)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($vrijeme)), __LINE__);
        }
        if (is_null($vrijeme) || (is_array($vrijeme) && empty($vrijeme))) {
            unset($this->Vrijeme);
        } else {
            $this->Vrijeme = $vrijeme;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\WebTermin
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
